local TracerName, TracerData = ...

local WBBfAInfo = {};
local WBNaz = {
	56057,
	56056,
}
local WBNzothInfo = {};
local WarfrontsName = {};
local WarfrontsState = {};
local WarfrontsInfo = {};
local WarCampaignInfo = {
	["Alliance"] = 57002; --ok 8.2.5
	["Horde"] = 57095;	--ok 8.2.5
	};
local AzeriteQuest = {
	["Alliance"] = 53436;
	["Horde"] = 53435;
	};
TracerData.EQBfAInfo = {
	["Available"] = {
		["Alliance"] = 51918;
		["Horde"] = 51916;			
		},
	["Name"] = {},		
	};	
local BfADailyNazjatar = {
	["Alliance"] = {		
		56001,
		56002,
		56000,
		56153,
		55683,
		55633,
		54949,
		55714,
		55662,
		55636,
		55845,
		55773,
		56149,
		56370,
		55777,
		56157,
		55659,
		56146,
		56155,
		55774,
		55625,
		56154,
		55750,
		56150,
		55771,
		55728,
		55681,
		55770,
		56158,
		55846,
		55775,
		55772,
		56152,
		56160,
		55776,
		55032,
		56159,
		55637,
		55701,
		},
	["Horde"] = {
		55871,
		56266,
		56035,
		56265,
		56233,
		56232,
		55767,
		55986,
		56151,
		56223,
		55715,
		55638,
		56264,
		56227,
		56222,
		56266,
		55985,
		55984,
		55873,
		56231,
		55768,
		56225,
		55993,
		55766,
		55980,
		55883,
		55874,
		55872,
		55664,
		55751,
		56224,
		55877,
		55876,
		55665,
		55663,
		55661,
		55878,
		56075,
		55875,
		},
	};

--Frame pour scanner l'état des warfronts de BfA
TracerData.ONUPDATE_INTERVAL = 1	-- The minimum number of seconds between each update
TracerData.TimeSinceLastUpdate = 0	-- The number of seconds since the last update
--Mise en route du scanner dans le core

--Création de la fenêtre
function TracerData.Function:WindowCreateBfA()
	--DB
	WBBfAInfo = {
	[52157] = {TracerData.L.WBBfA[140252], C_Map.GetMapInfo(896).name},	--Assemblage - Drustvar
	[52181] = {TracerData.L.WBBfA[132701], C_Map.GetMapInfo(863).name},	--T'zane - Nazmir
	[52169] = {TracerData.L.WBBfA[132253], C_Map.GetMapInfo(862).name},	--Ji'arak - Zuldazar
	[52163] = {TracerData.L.WBBfA[136385], C_Map.GetMapInfo(895).name},	--Azuréthos - Rade de Tiragarde
	[52166] = {TracerData.L.WBBfA[140163], C_Map.GetMapInfo(942).name},	--Yenajz - Vallée Chantorage
	[52196] = {TracerData.L.WBBfA[138794], C_Map.GetMapInfo(864).name},	--Krolauk - Vol'dun
	};
	WBNzothInfo = {
	[58705] = {TracerData.L.WBNzoth[154638], C_Map.GetMapInfo(390).name},	--Val
	[55466] = {TracerData.L.WBNzoth[160970], C_Map.GetMapInfo(249).name},	--Vul'kaz - Uldum
	};	
	--Warfronts
	if UnitFactionGroup("player") == "Alliance" then
		WarfrontsInfo = {
			[1] = {0, 56136, 52847, 52847},	--contrib, idquest siège, idquest WB
			[2] = {0, 57960, 54895, 54895},	--contrib, idquest siège, idquest WB
			};
	else
		WarfrontsInfo = {
			[1] = {0, 53416, 52848, 52848},	--contrib, idquest siège, idquest WB
			[2] = {0, 53995, 54895, 54895},	--contrib, idquest siège, idquest WB		--need
			};
	end
	WarfrontsState = {
		TracerData.L["Contibution"],
		TracerData.L["Siège"],
		TracerData.L["Patrouille"],
		TracerData.L["Patrouille"],		
		};	
	WarfrontsName = {
		TracerData.L["Bataille Stromgarde"],
		TracerData.L["Bataille Sombrivage"],
		};
	--EQ
	TracerData.EQBfAInfo.Name = {
		--Quêtes d'émissaires de BfA
		--Both
		[50604] = 2163, --"Chercheur Tortollans",		
		[50562] = 2164, --"Champions d'Azeroth",		
		--Alliance
		[50599] = 2160, --"Amirauté Portvaillant",
		[50601] = 2162, --"Sillage des tempêtes",
		[50600] = 2161, --"Ordre des Braises",
		[50605] = 2159, --"7e Legion",
		[56119] = 2400, --"Les Ankoïens du Brisant",
		--Horde
		[50598] = 2103, --"Empire Zandalari",
		[50602] = 2156, --"Expédition de Talanji",
		[50603] = 2158, --"Volduni",
		[50606] = 2157, --"Les Honorables",
		[56120] = 2373, --"Les Affranchis",		
		};
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[2];
	TracerDB.ListLine[2] = {
		TracerData.L["Quêtes d'emmisaires"],
		TracerData.L["Coeur d'Azeroth"],
		TracerData.L["Exploration d'îles"],
		TracerData.L["WB BfA"],
		TracerData.L["Quêtes BfA"],	
		TracerData.L["Bataille Stromgarde"],
		TracerData.L["Bataille Sombrivage"],
		TracerData.L["Nazjatar daily"],
		TracerData.L["Nazjatar weekly"],
		TracerData.L["Mechagon"],
		TracerData.L["Assaults"],
		TracerData.L["MiniVision"],	
		TracerData.L["WB Nzoth"],
		"Ashjra'kamas",
		};
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(2, headername);

	--Affichage
	TracerData.Function:WindowUpdateBfA();
	
	--Tooltip pour les quêtes d'émissaires
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[2]["Toon"..index][1]:SetScript("OnEnter", function()
			TracerData.Function:EQTooltip("BfA", value);
		end);
		TracerData.Lines[2]["Toon"..index][1]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end	

	--Tooltip pour le Coeur d'Azeroth
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[2]["Toon"..index][2]:SetScript("OnEnter", function()
			TracerData.Function:HeartofAzerothTooltip(value);
		end);
		TracerData.Lines[2]["Toon"..index][2]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end	

	--Tooltip pour les quêtes BfA
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[2]["Toon"..index][5]:SetScript("OnEnter", function()
			TracerData.Function:QuestsBfATooltip(value);
		end);
		TracerData.Lines[2]["Toon"..index][5]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end
	
	--Tooltip pour les hebdo Nazjatar
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[2]["Toon"..index][9]:SetScript("OnEnter", function()
			TracerData.Function:NazjatarWeeklyTooltip(value);
		end);
		TracerData.Lines[2]["Toon"..index][9]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end		

	--Tooltip pour les daily Mechagon
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[2]["Toon"..index][10]:SetScript("OnEnter", function()
			TracerData.Function:MechagonDailyTooltip(value);
		end);
		TracerData.Lines[2]["Toon"..index][10]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end	

	--Tooltip pour les assaults
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[2]["Toon"..index][11]:SetScript("OnEnter", function()
			TracerData.Function:AssaultsTooltip(value);
		end);
		TracerData.Lines[2]["Toon"..index][11]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end

	--Gestion Quêtes d'emissaires de BfA
	TracerData.Lines[2][1]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[2][1]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[2][1]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:EmissaryQuestsChecking("BfA");			
		end)	

	--Gestion du Coeur d'Azeroth
	TracerData.Lines[2][2]:RegisterEvent("AZERITE_ITEM_EXPERIENCE_CHANGED");
	TracerData.Lines[2][2]:RegisterEvent("AZERITE_ITEM_POWER_LEVEL_CHANGED");	
	TracerData.Lines[2][2]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:AzeriteChecking();		
	end)
	
	--Gestion des quêtes de BfA
	TracerData.Lines[2][3]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[2][3]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[2][3]:SetScript("OnEvent", function(_, event, arg1) 
		C_Timer.After(3, function() TracerData.Function:QuestsCheckingBfA(); end) 
		end)

	--Gestion du WB de BfA
	TracerData.Lines[2][4]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[2][4]:SetScript("OnEvent", function(_, event) 
		C_Timer.After(3, function() TracerData.Function:WorldBossCheckingBfA() end) 
	end)
	
	--Gestion des Warfronts
	TracerData.Lines[2][6]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[2][6]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[2][6]:SetScript("OnEvent", function(_, event)	
		if UnitFactionGroup("player") ~= "Neutral" then
			TracerData.Function:WarfrontToonChecking(1, TracerDB.WarfrontsBfA[UnitFactionGroup("player")][1], 6);
			TracerData.Function:WarfrontToonChecking(2, TracerDB.WarfrontsBfA[UnitFactionGroup("player")][2], 7);
		end
	end)
	
	--Gestion des quêtes de Nazjatar
	TracerData.Lines[2][8]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[2][8]:SetScript("OnEvent", function(_, event, arg1) 
		C_Timer.After(3, function() TracerData.Function:QuestsCheckingBfANazjatar(); end) 
		end)	
		
	--Gestion des quêtes Mechagon
	TracerData.Lines[2][10]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[2][10]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:QuestsCheckingBfAMechagon();		
	end)

	--Gestion des assaults de N'Zoth
	TracerData.Lines[2][11]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[2][11]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:AssaultsChecking();		
	end)
	
	--Gestion des réceptacles (vision)
	TracerData.Lines[2][14]:RegisterEvent("BAG_UPDATE");
	TracerData.Lines[2][14]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:VesselsChecking();
	end)		
end

function TracerData.Function:WindowUpdateBfA()
	local count = 0;	--pour compter lignes 9 et 10
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[2], 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon
				if value == key1 then
					TracerData.Lines[2]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--"Quêtes d'emmisaires"
					if i == 1 then
						if value1["Quests"]["EQBfA"][1] == 3 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["EQBfA"][1] == 2 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
						elseif value1["Quests"]["EQBfA"][1] == 1 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");
						elseif value1["Quests"]["EQBfA"][1] == 0 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end
					--"Coeur d'Azeroth"
					if i == 2 then
						if value1.Azerite.active then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(value1.Azerite.lvl);
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end					
					--"Exploration d'îles"
					if i == 3 then
						if value1.Quests.BfA["IE"][1] == 0 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(tostring(math.floor(100 * value1.Quests.BfA["IE"][2] / 36000)).." %");
						elseif value1.Quests.BfA["IE"][1] == 1 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
						else					
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
						end	
					end
					--"WB BfA"
					if i == 4 then
						TracerData.Lines[2][i]["Title"]:SetText("WB BfA : "..TracerDB.WBBfA);
						TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
						TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						if value1["Quests"]["WBBfA"] == 0 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["WBBfA"] == 1 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end	
					--"Quêtes BfA" (5)
					if i == 5 then
						count = -1;
						if value1.Level >= 50 then
							count = 0;
							for index2, value2 in ipairs(value1.Quests.BfA.Quests) do
								count = count + value2;
							end
						end
						if count == -1 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);						
						elseif count == 0 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");						
						elseif count == 9 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");						
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(count.."/9");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);						
						end
					end
					--"Bataille de Stromgarde" (6) --"Bataille de Sombrivage" (7)
					if (i == 6) or (i == 7) then
						if UnitFactionGroup("player") == "Neutral" then
							TracerData.Lines[2][i]["Title"]:SetText("NA - Neutral Faction");
						else
							TracerData.Lines[2][i]["Title"]:SetText(WarfrontsName[i-5].." - "..WarfrontsState[TracerDB.WarfrontsBfA[UnitFactionGroup("player")][i-5]]);						
						end
						if value1["Faction"] == UnitFactionGroup("player") then
							if (value1["Quests"]["BfA"]["Warfronts"][i-5] == -2) or (value1.Level < 50) then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");						
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);	
							elseif value1["Quests"]["BfA"]["Warfronts"][i-5] == -1.5 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);						
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);								
							elseif value1["Quests"]["BfA"]["Warfronts"][i-5] == -1 then						
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);	
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							elseif value1["Quests"]["BfA"]["Warfronts"][i-5] == 0 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
							else
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							end
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");						
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						end
					end	
					if i == 8 then
						if value1.Quests.BfA["Nazjatar"]["Daily"] == -1 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");							
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);							
						elseif value1.Quests.BfA["Nazjatar"]["Daily"] == 0 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);							
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1.Quests.BfA["Nazjatar"]["Daily"] == 1 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);							
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");					
						elseif value1.Quests.BfA["Nazjatar"]["Daily"] == 2 then
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);							
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");								
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						end
					end	
					if i == 9 then
						if TracerDB.Toons[value]["Level"] >=50 then
							count = TracerDB["Toons"][value]["Quests"]["WBNaz"] + TracerDB.Toons[value]["Quests"]["BfA"]["Nazjatar"]["Weekly"][1];
							if count <= 0 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							elseif count == 1 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
							else
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");							
							end
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);					
						end
					end	
					if i == 10 then
						if TracerDB.Toons[value]["Level"] >= 50 then
							count = TracerDB["Toons"][value]["Quests"]["BfA"]["Mechagon"][1] + TracerDB.Toons[value]["Quests"]["BfA"]["Mechagon"][2] + TracerDB.Toons[value]["Quests"]["BfA"]["Mechagon"][3];
							if count <= 0 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							elseif count == 1 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
							elseif count == 2 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");								
							else
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");							
							end
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);					
						end
					end
					--N'zoth Assaults
					if i == 11 then
						if TracerDB.Toons[value]["Quests"]["BfA"]["Quests"][8] == 1 then
							count = TracerDB["Toons"][value]["Quests"]["BfA"]["Assaults"][1] + TracerDB.Toons[value]["Quests"]["BfA"]["Assaults"][2];
							if count == 0 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("0/2");
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);							
							elseif count == 1 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("1/2");
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);							
							elseif count == 2 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");							
							end
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);					
						end
					end	
					--N'zoth Mini-Vision
					if i == 12 then
						if (TracerDB.Toons[value]["Level"] >= 50) and (TracerDB["Toons"][value]["Quests"]["BfA"]["Quests"][8] == 1) then
							if TracerDB["Toons"][value]["Quests"]["BfA"]["MiniVision"] == 1 then
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");														
							else
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");							
							end
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);					
						end
					end	
					--WB Nzoth
					if i == 13 then					
						TracerData.Lines[2][i]["Title"]:SetText("WB N'zoth : "..TracerDB.WBNzoth);
						TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);
						TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						if value1["Quests"]["WBNzoth"] == 0 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["WBNzoth"] == 1 then
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);							
						end					
					end
					--Ashjra'kamas
					if i == 14 then					
						if value1.Quests.BfA.Quests[9] == 1 then
							if value1.Quests.BfA["Ashjra'kamas"][1] and (value1.Quests.BfA["Ashjra'kamas"][1] ~= 0) then
								if value1.Quests.BfA["Ashjra'kamas"][2] and (value1.Quests.BfA["Ashjra'kamas"][2]) ~= 0 then
									TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(value1.Quests.BfA["Ashjra'kamas"][1].." ("..value1.Quests.BfA["Ashjra'kamas"][2]..")");								
									TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);
								else
									TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(value1.Quests.BfA["Ashjra'kamas"][1]);								
									TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);								
								end
							else
								TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText(nil);							
								TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);						
							end
						else
							TracerData.Lines[2]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[2]["Toon"..index][i]["Texture2"]:SetTexture(nil);							
						end					
					end					
				end
			end
		end
	end
end

--Checking
function TracerData.Function:QuestsCheckingBfA()
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 50 then return end 
	
	local idquest = {
		55533,	--Vol Noir (ok)	
		55398,	--Vol Vert (ok)
		55657,	--Vol Rouge (ok)
		56401,	--Vol Bleu (ok)
		55521,	--Hyjal (ok)	
		55737,	--Maelström (ok)
		0,	--Naz'jatar
		57290,	--Ashjra'kamas (ok)		
		};
	if TracerDB.Toons[TracerData.thisToon]["Faction"] == "Alliance" then
		idquest[7] = 56156;
	else
		idquest[7] = 55500;	
	end
	
	--Quête d'exploration d'îles (ligne 3)
	if C_QuestLog.IsQuestFlaggedCompleted(AzeriteQuest[TracerDB.Toons[TracerData.thisToon]["Faction"]]) then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["IE"][1] = 1 ;
	else
		local questInfo = C_QuestLog.GetQuestObjectives(AzeriteQuest[TracerDB.Toons[TracerData.thisToon]["Faction"]]);
		if questInfo and questInfo[1] then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["IE"][1] = 0 ;
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["IE"][2] = questInfo[1]["numFulfilled"];
		end
	end
	
	--Quêtes BfA (ligne 5)
	--Campagne de guerre
	if C_QuestLog.IsQuestFlaggedCompleted(WarCampaignInfo[TracerDB.Toons[TracerData.thisToon]["Faction"]]) then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Quests"][1] = 1 ;
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Quests"][1] = 0 ;						
	end	
	--Azérite
	for index, value in ipairs(idquest) do
		if C_QuestLog.IsQuestFlaggedCompleted(value) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Quests"][index+1] = 1 ;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Quests"][index+1] = 0 ;						
		end	
	end	
	
	--Mini-Vision
	local minivisionidquests = {
		58168,
		58155,
		58151,
		58167,
		58156,
		57874,
		};
	count = 0;
	for index, value in ipairs(minivisionidquests) do 
		if C_QuestLog.IsQuestFlaggedCompleted(value) then
			count = 1;
		end
	end
	TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["MiniVision"] = count;
	
	--Affichage
	--TracerData.Function:WindowUpdateBfA();
end

function TracerData.Function:WorldBossCheckingBfA()
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 50 then return end
	
	--WB KulTiras ou Zandalar
	if TracerDB.Toons[TracerData.thisToon]["Level"] >= 50 then	
		for key, value in pairs(WBBfAInfo) do
			if	C_QuestLog.IsQuestFlaggedCompleted(key) then
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBBfA"] = 1;					
				TracerDB.WBBfA = value[1].." - "..value[2]; --Sauvegarde du nom du WeekBoss de la semaine
				break;
			else
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBBfA"] = 0;				
			end
		end
	else
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBBfA"] = -1;	
	end
	
	--WB Nzoth
	if C_QuestLog.IsQuestFlaggedCompleted(58506) then
		for key, value in pairs(WBNzothInfo) do
			if	C_QuestLog.IsQuestFlaggedCompleted(key) then
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBNzoth"] = 1;	
				TracerDB.WBNzoth = value[1].." - "..value[2]; --Sauvegarde du nom du WeekBoss de la semaine
				break;
			else
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBNzoth"] = 0;				
			end
		end
	else
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBNzoth"] = -1;						
	end
	
	--Affichage
	--TracerData.Function:WindowUpdateBfA();	
end

function TracerData.Function:WarfrontToonChecking(nummap, numstate, numline)		--MODIF

	if TracerDB.Toons[TracerData.thisToon]["Level"] < 50 then --Warfronts accésibles au niveau 50
		TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Title"]:SetText("NA");
		return 
	end

	if (nummap == 2) and (TracerDB.Toons[TracerData.thisToon]["Ilvl"] < 82) then --Sombrivage uniquement pour les peros avec un ilvl assez élevé		--debug
		TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Title"]:SetText("NA");
		TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture(nil);		
		return 
	end	

	TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture(nil);	
	TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Title"]:SetText(nil);
	TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Warfronts"][nummap] = -1.5;
	
	local questLogIndex = C_QuestLog.GetLogIndexForQuestID(WarfrontsInfo[nummap][numstate]);
	if numstate == 2 then
		if C_QuestLog.IsQuestFlaggedCompleted(WarfrontsInfo[nummap][numstate]) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Warfronts"][nummap] = 1;
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");			
		elseif questLogIndex ~= 0 then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Warfronts"][nummap] = 0;
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");		
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Warfronts"][nummap] = -1;
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");			
		end
	elseif numstate == 4 then
		if C_QuestLog.IsQuestFlaggedCompleted(WarfrontsInfo[nummap][numstate]) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Warfronts"][nummap] = 1;
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Warfronts"][nummap] = -1;
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][numline]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");		
		end	
	end
end

function TracerData.Function:AzeriteChecking()
 	if TracerDB.Toons[TracerData.thisToon]["Level"] > 50 then return end
	
	--Détermine si l'objet est actif
	TracerDB.Toons[TracerData.thisToon]["Azerite"]["active"] = C_AzeriteItem.HasActiveAzeriteItem();	--(true/false)
	if not TracerDB.Toons[TracerData.thisToon]["Azerite"]["active"] then return end
	--Récupération des informations
	local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem();
	if azeriteItemLocation then
		TracerDB.Toons[TracerData.thisToon]["Azerite"]["lvl"] = C_AzeriteItem.GetPowerLevel(azeriteItemLocation);
		TracerDB.Toons[TracerData.thisToon]["Azerite"]["xp"], TracerDB.Toons[TracerData.thisToon]["Azerite"]["xptotal"] = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation);	
		--Affichage
		TracerData.Lines[2]["Toon"..TracerData.numthisToon][2]["Title"]:SetText(TracerDB.Toons[TracerData.thisToon]["Azerite"]["lvl"]);			
	end	
end

function TracerData.Function:WarfrontsBfAChecking()
	local t = {};	
	local id1 = {
		[11] = 116, --Arathi Horde
		[116] = 11,	--Arathi Alliance 
		[117] = 118, 	--Sombrivage Alliance
		[118] = 117,	--Sombrivage Horde
		};
	local idA = {
		[116] = {1, 11},	--Arathi Alliance
		[117] = {2, 118}, 	--Sombrivage Alliance
		};
	local idH = {
		[11] = {1, 116}, --Arathi Horde	
		[118] = {2, 117},	--Sombrivage Horde	
		};
	t.time = time();
	local remaining = 0;
	local contributionState, contributionPercentageComplete, timeOfNextStateChange, startTime = 0, 0, 0, 0;
	--Récupération des infos
	for key, value in pairs(id1) do
		local contributionState, contributionPercentageComplete, timeOfNextStateChange, startTime = C_ContributionCollector.GetState(key);
		t[key] = {};
		t[key]["contributionState"] = contributionState;
		t[key]["contributionPercentageComplete"] = math.floor(contributionPercentageComplete * 10000)/100;
		t[key]["timeOfNextStateChange"] = timeOfNextStateChange;
		t[key]["startTime"] = startTime;
		--Sauvegarde des infos
		TracerDB.WarfrontsBfA.contributions = t;		
	end
	
	local ids = {};
	if UnitFactionGroup("player") == "Alliance" then
		ids = idA
	else
		ids = idH
	end
	
	for key, value in pairs(ids) do
		if TracerDB.WarfrontsBfA.contributions[key]["contributionState"] == 1 then			--Contribution
			TracerData.Lines[2][value[1]+5]["Title"]:SetText(WarfrontsName[value[1]].." : "..WarfrontsState[1].." ("..TracerDB.WarfrontsBfA.contributions[key]["contributionPercentageComplete"].." %)");
			if TracerDB.WarfrontsBfA[UnitFactionGroup("player")][value[1]] ~= 1 then				
				TracerData.Function:WarfrontsReset(value[1], 1);
			end
			TracerDB.WarfrontsBfA[UnitFactionGroup("player")][value[1]] = 1;
		elseif TracerDB.WarfrontsBfA.contributions[key]["contributionState"] == 2 then		--Siège
			if TracerDB.WarfrontsBfA.contributions[key]["timeOfNextStateChange"] ~= nil then
				remaining = TracerDB.WarfrontsBfA.contributions[key]["timeOfNextStateChange"]-time();
			end
			TracerData.Lines[2][value[1]+5]["Title"]:SetText(WarfrontsName[value[1]].." : "..WarfrontsState[2].." - "..TracerData.Function:RemainingTime(remaining));
			if TracerDB.WarfrontsBfA[UnitFactionGroup("player")][value[1]] ~= 2 then
				TracerData.Function:WarfrontsReset(value[1], 2);
			end	
			TracerDB.WarfrontsBfA[UnitFactionGroup("player")][value[1]] = 2;			
		elseif TracerDB.WarfrontsBfA.contributions[key]["contributionState"] == 4 then		--Patrouille
			if TracerDB.WarfrontsBfA.contributions[value[2]]["timeOfNextStateChange"] ~= nil then
				remaining = TracerDB.WarfrontsBfA.contributions[value[2]]["timeOfNextStateChange"]-time();
				TracerData.Lines[2][value[1]+5]["Title"]:SetText(WarfrontsName[value[1]].." : "..WarfrontsState[4].." - "..TracerData.Function:RemainingTime(remaining));					
			else
				TracerData.Lines[2][value[1]+5]["Title"]:SetText(WarfrontsName[value[1]].." : "..WarfrontsState[3].." ("..TracerDB.WarfrontsBfA.contributions[value[2]]["contributionPercentageComplete"].." %)");						
			end						
			if TracerDB.WarfrontsBfA[UnitFactionGroup("player")][value[1]] ~= 4 then
				TracerData.Function:WarfrontsReset(value[1], 4);	
			end				
			TracerDB.WarfrontsBfA[UnitFactionGroup("player")][value[1]] = 4;
		end
	end
end

function TracerData.Function:WarfrontsReset(numwarfront, numstate)
	--Reset des données
	for key, value in pairs(TracerDB.Toons) do
		if value["Faction"] == UnitFactionGroup("player") then
			if value["Quests"]["BfA"]["Warfronts"][numwarfront] ~= -2 then
				if numstate == 1 then
					value["Quests"]["BfA"]["Warfronts"][numwarfront] = -1.5;
				else			
					value["Quests"]["BfA"]["Warfronts"][numwarfront] = -1;
				end
			end
		end
	end
	--Affichage pour les Toons
	for index, value in ipairs(TracerData.ListToons) do
		if TracerDB.Toons[value]["Faction"] == UnitFactionGroup("player") then
			if (TracerDB.Toons[value]["Quests"]["BfA"]["Warfronts"][numwarfront] == -2) or (TracerDB.Toons[value].Level < 50) then
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Title"]:SetText("NA");						
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Texture2"]:SetTexture(nil);
			elseif TracerDB.Toons[value]["Quests"]["BfA"]["Warfronts"][numwarfront] == -1.5 then
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Title"]:SetText(nil);						
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Texture2"]:SetTexture(nil);						
			elseif TracerDB.Toons[value]["Quests"]["BfA"]["Warfronts"][numwarfront] == -1 then						
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Title"]:SetText(nil);	
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
			elseif TracerDB.Toons[value]["Quests"]["BfA"]["Warfronts"][numwarfront] == 0 then
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Title"]:SetText(nil);
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
			else
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Title"]:SetText(nil);
				TracerData.Lines[2]["Toon"..index][numwarfront+5]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
			end
		end
	end
end

function TracerData.Function:QuestsCheckingBfANazjatar()
	local count = 0;
	if UnitLevel("player") >= 50 then
		--Scan journa combattant alliés
		for index, value in ipairs(BfADailyNazjatar[UnitFactionGroup("player")]) do
			if C_QuestLog.IsQuestFlaggedCompleted(value) then
				count = count + 1;
			end
		end
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Nazjatar"]["Daily"] = count;
		--Affichage Combattant allié
		if count == 0 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
		elseif count == 1 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Title"]:SetText(nil);	
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
		elseif count == 2 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Title"]:SetText(nil);	
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");						
		elseif count == 3 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Title"]:SetText(nil);	
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		else
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Title"]:SetText("NA");
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][8]["Texture2"]:SetTexture(nil);
		end					
		
		--Scan Mardivas
		if C_QuestLog.IsQuestFlaggedCompleted(55121) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Nazjatar"]["Weekly"][1] = 1;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Nazjatar"]["Weekly"][1] = 0;
		end
		--Scan WB Nazjatar
		for index, value in ipairs(WBNaz) do
			if C_QuestLog.IsQuestFlaggedCompleted(value) then
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBNaz"] = 1;			
				break;
			else
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBNaz"] = 0;
			end
		end
		--Affichage
		count = TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBNaz"] + TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Nazjatar"]["Weekly"][1];
		if count == 0 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][9]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][9]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");		
		elseif count == 1 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][9]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][9]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
		else
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][9]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][9]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		end
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Nazjatar"]["Weekly"][1] = -1;
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Nazjatar"]["Daily"] = -1;	
	end
end

function TracerData.Function:QuestsCheckingBfAMechagon()
	local count = 0;
	local idquest = {56141, 56139, 55901};	--daily à 850

	if UnitLevel("player") >= 50 then
		--Scan daily à 850pts
		for index, value in ipairs(idquest) do
			if C_QuestLog.IsQuestFlaggedCompleted(value) then
				TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][1] = 1;
				break;
			else
				TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][1] = 0;
			end
		end	
		--Scan recycling
		if C_QuestLog.IsQuestFlaggedCompleted(55743) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][2] = 1;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][2] = 0;
		end	
		--Scan WM quest
		if C_QuestLog.IsQuestFlaggedCompleted(57327) or C_QuestLog.IsQuestFlaggedCompleted(57326) then	--Ally, Horde
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][3] = 1;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][3] = 0;
		end			
		--Affichage
		count = TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][1] + TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][2] + TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][3];
		if count == 0 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");		
		elseif count == 1 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
		elseif count == 2 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");			
		else
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][10]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		end		
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][1] = -1;
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][2] = -1;
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Mechagon"][3] = -1;		
	end	
end

function TracerData.Function:AssaultsChecking()
	--1 pour le Val, 2 pour Uldum
	
	local count = 0;
	local AssaultsID = {
		["Val"] = {
			57728,	--Mantides
			57008, 	--Mogu	
			56064,	--N'zoth : Val de l'Eternel Primptemps		
			},			
		["Uldum"] = {
			55350,	--Amaneth
			56308, 	--Aqir
			57157,	--N'zoth : Uldum			
			},
		["Nzoth"] = {
			56064,	--N'zoth : Val de l'Eternel Primptemps		
			57157,	--N'zoth : Uldum	
			},			
		};
	
	if C_QuestLog.IsQuestFlaggedCompleted(56472) then
		--Nzoth : Détection de la zone
		for index, value in ipairs(AssaultsID.Nzoth) do
			if C_QuestLog.IsQuestFlaggedCompleted(value) then
				TracerDB.AssaultNzothMap[1] = index;
			end
		end
		--Val
		count = 0;
		for index, value in ipairs(AssaultsID.Val) do
			if C_QuestLog.IsQuestFlaggedCompleted(value) then
				count = count + 1;
			end
		end
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Assaults"][1] = count;
		--Uldum
		count = 0;
		for index, value in ipairs(AssaultsID.Uldum) do
			if C_QuestLog.IsQuestFlaggedCompleted(value) then
				count = count + 1;
			end
		end
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Assaults"][2] = count;	
		
		count = TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Assaults"][1]+TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Assaults"][2];
		if count == 0 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Title"]:SetText(count.."/2");
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Texture2"]:SetTexture(nil);		
		elseif count == 1 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Title"]:SetText(count.."/2");
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Texture2"]:SetTexture(nil);		
		elseif count == 2 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Title"]:SetText(nil);
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");		
		end
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Assaults"][1] = 0;
		TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Assaults"][2] = 0;		
		TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Title"]:SetText("NA");
		TracerData.Lines[2]["Toon"..TracerData.numthisToon][11]["Texture2"]:SetTexture(nil);		
	end	
end

function TracerData.Function:AssaultsResetChecking()
	if TracerDB["AssaultNzothMap"][2] == 1 then return end

	local Date = date("*t");
	local count = 0;
	local resetWeekly = TracerDB["Reset"]["resetweekly"] - 302400;	--reset de l'asault mineur 3.5j avant le reset weekly
	
	if time() > resetWeekly then
		TracerDB["AssaultNzothMap"][2] = 1;	--On sauvegarde le reset
		if TracerDB["AssaultNzothMap"][1] == 1 then
			for key, value in pairs(TracerDB.Toons) do
				value["Quests"]["BfA"]["Assaults"][2] = 0;
			end
		end
		if TracerDB["AssaultNzothMap"][1] == 2 then
			for key, value in pairs(TracerDB.Toons) do
				value["Quests"]["BfA"]["Assaults"][1] = 0;
			end		
		end	
	end	
	--Affichage
	if TracerDB["AssaultNzothMap"][2] == 1 then
		for i=1, #TracerData.ListToons do
			TracerData.Lines[2]["Toon"..i][11]["Texture2"]:SetTexture(nil);
			count = TracerDB.Toons[TracerData.ListToons[i]]["Quests"]["BfA"]["Assaults"][1] + TracerDB.Toons[TracerData.ListToons[i]]["Quests"]["BfA"]["Assaults"][2];
			if count == 1 then
				TracerData.Lines[2]["Toon"..i][11]["Title"]:SetText("1/2");			
			else
				TracerData.Lines[2]["Toon"..i][11]["Title"]:SetText("0/2");	
			end
		end
	end
end

function TracerData.Function:VesselsChecking()
	local numvessels = TracerData.Function:GetContainerNumItem(173363);	
	local rankback = TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Ashjra'kamas"][1];
	TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Ashjra'kamas"][2] = numvessels;

	--Affichage
	if rankback ~= 0 then
		if numvessels ~= 0 then
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][14]["Title"]:SetText(rankback.." ("..numvessels..")");								
		else
			TracerData.Lines[2]["Toon"..TracerData.numthisToon][14]["Title"]:SetText(rankback);																
		end
	end
end

--Getions des Tooltips
function TracerData.Function:QuestsBfATooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	for i=1, 9, 1 do
		if TracerDB.Toons[toon]["Quests"]["BfA"]["Quests"][i] == 1 then
		    GameTooltip:AddLine(TracerData.L["BFAQuests"][i], 0, 1, 0);	
		else
		    GameTooltip:AddLine(TracerData.L["BFAQuests"][i], 1, 0, 0);		
		end	
	end	
	GameTooltip:Show();	
end

function TracerData.Function:HeartofAzerothTooltip(value)
	if not TracerDB.Toons[value]["Azerite"]["active"] then return end

	local t = TracerDB.Toons[value];
	--if t.Azerite.lvl == 70 then return end
	local r, g, b = t["ClassColor"]["r"], t["ClassColor"]["g"], t["ClassColor"]["b"]
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
	
	GameTooltip:AddDoubleLine(t.Name, TracerData.L["Cœur d'Azeroth"], r, g, b);
	GameTooltip:AddDoubleLine(TracerData.L["Niveau"], t.Azerite.lvl, 1, 1, 1, 1 ,1, 1);	
	GameTooltip:AddDoubleLine(TracerData.L["Prochain niveau"], t.Azerite.xptotal-t.Azerite.xp.." ("..string.format("%.1f", (t.Azerite.xptotal-t.Azerite.xp)/t.Azerite.xptotal*100).." %)", 1, 1, 1, 1 ,1, 1);	

	GameTooltip:Show();
end

function TracerData.Function:NazjatarWeeklyTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	
	--WB Naz
	if TracerDB["Toons"][toon]["Quests"]["WBNaz"] == 1 then
		GameTooltip:AddLine("WB Nazjatar", 0, 1, 0);
	else
		GameTooltip:AddLine("WB Nazjatar", 1, 0, 0);	
	end
	--Mardivas
	if TracerDB.Toons[toon]["Quests"]["BfA"]["Nazjatar"]["Weekly"][1] == 1 then
		GameTooltip:AddLine("Mardivas", 0, 1, 0);	
	else
		GameTooltip:AddLine("Mardivas", 1, 0, 0);	
	end	
	
	GameTooltip:Show();
end

function TracerData.Function:MechagonDailyTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	
	--Daily à 850 pts
	if TracerDB["Toons"][toon]["Quests"]["BfA"]["Mechagon"][1] == 1 then
		GameTooltip:AddLine(TracerData.L["Mechagon daily"], 0, 1, 0);
	else
		GameTooltip:AddLine(TracerData.L["Mechagon daily"], 1, 0, 0);	
	end
	--Quête recyclage
	if TracerDB["Toons"][toon]["Quests"]["BfA"]["Mechagon"][2] == 1 then
		GameTooltip:AddLine(TracerData.L["Mechagon recycling"], 0, 1, 0);	
	else
		GameTooltip:AddLine(TracerData.L["Mechagon recycling"], 1, 0, 0);	
	end	
	--WM quête
	if TracerDB["Toons"][toon]["Quests"]["BfA"]["Mechagon"][3] == 1 then
		GameTooltip:AddLine(TracerData.L["Mechagon WM"], 0, 1, 0);	
	else
		GameTooltip:AddLine(TracerData.L["Mechagon WM"], 1, 0, 0);	
	end	
	GameTooltip:Show();
end

function TracerData.Function:AssaultsTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 50 then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[toon]["Name"], r, g, b);
	
	if TracerDB.Toons[toon]["Quests"]["BfA"]["Assaults"][1] == 1 then
		GameTooltip:AddLine(TracerData.L["Val"], 0, 1, 0);
	else
		GameTooltip:AddLine(TracerData.L["Val"], 1, 0, 0);	
	end
	if TracerDB.Toons[toon]["Quests"]["BfA"]["Assaults"][2] == 1 then
		GameTooltip:AddLine("Uldum", 0, 1, 0);	
	else
		GameTooltip:AddLine("Uldum", 1, 0, 0);	
	end
	
	GameTooltip:Show();
end