local TracerName, TracerData = ...

TracerData.FactionsInfos = {
	--DragonFlight (DF)	(9)
	{2503, " ", "DF", false}, -- Centaure maruuk
	{2507, " ", "DF", false}, -- Expédition du Dracaret
	{2526, " ", "DF", false}, -- Furbolg crin-d'hiver
	{2511, " ", "DF", false}, -- Rohart iskaarien
	{2510, " ", "DF", false}, -- Concardat de Valdrakken
	{2550, " ", "DF", false}, -- Assemblée de Cobalt
	{2544, " ", "DF", false}, -- Consortium d'aritsanat
	{2517, " ", "DF", false}, -- Irion
	{2518, " ", "DF", false}, -- Sabellian	
	--Shadowlands (SL) (8)
	{2407, " ", "SL", false}, -- Transcendés
	{2413, " ", "SL", false}, -- Cour des Moissonneurs
	{2465, " ", "SL", false}, -- L'Hallali
	{2410, " ", "SL", false}, -- Armée immortelle
	{2432, " ", "SL", false}, -- Venari (antre)
	{2470, " ", "SL", false}, -- Avancée de la mort
	{2464, " ", "SL", false}, -- Cour de la nuit
	{2478, " ", "SL", false}, -- Les Eclairés	
	-- Battle for Azeroth (15)
	{2103, " ", "BfA", false}, -- Empire Zandalari (H)
	{2156, " ", "BfA", false}, -- Expedition de Talanji (H)
	{2157, " ", "BfA", false}, -- Brigade de l'honneur (H)
	{2158, " ", "BfA", false}, -- Volduni (H)
	{2159, " ", "BfA", false}, -- 7e Legion (A)
	{2160, " ", "BfA", false}, -- Amirauté des Portvaillants (A)
	{2161, " ", "BfA", false}, -- Ordre des Braises (A)
	{2162, " ", "BfA", false}, -- Sillage des tempêtes (A)
	{2163, " ", "BfA", false}, -- Chercheurs Tortollans
	{2164, " ", "BfA", false}, -- Champions d'Azeroth
	{2373, " ", "BfA", false}, -- Les Affranchis (H)
	{2391, " ", "BfA", false}, -- Résistance de Mécarouille
	{2400, " ", "BfA", false}, -- Ankoïens du brisant (A)
	{2415, " ", "BfA", false}, -- Radjani	
	{2417, " ", "BfA", false}, -- Ankoïens du brisant	
	--{2395, " ", "BfA"}, -- Essaim Dos-de-Miel (A)	
	-- Legion (9)
	{1828, " ", "Legion", false}, -- Tribu de Haut-Roc
	{1859, " ", "Legion", false}, -- Les Soufrenuits
	{1883, " ", "Legion", false}, -- Le Tisserêve
	{1894, " ", "Legion", false}, -- Les Gardiennes
	{1900, " ", "Legion", false}, -- Court de Farondis
	{1948, " ", "Legion", false}, -- Valarjar
	{2045, " ", "Legion", false}, -- Armée du Déclin de la Légion
	{2165, " ", "Legion", false}, -- Armée de la lumière
	{2170, " ", "Legion", false}, -- Front arguséen
	-- Warlords of Draenor (12)
	{1711, " ", "WoD", false}, -- Société de conservation de Gentepression
	{1848, " ", "WoD", false}, -- Chasseurs de têtes de Vol'jin
	{1849, " ", "WoD", false}, -- Ordre des Éveillés
	{1847, " ", "WoD", false}, -- Main du prophète
	{1850, " ", "WoD", false}, -- Traquesabres
	{1708, " ", "WoD", false}, -- Orcs du Crânes-Ricanant
	{1445, " ", "WoD", false}, -- Orcs loups-de-givre
	{1515, " ", "WoD", false}, -- Parias arakkoa
	{1710, " ", "WoD", false}, -- Défense sha'tari
	{1731, " ", "WoD", false}, -- Conseil des exarques
	--{1735, " ", "WoD"}, -- Gardes des corps de caserne
	{1520, " ", "WoD", false}, -- Exilés ombrelunes
	{1732, " ", "WoD", false}, -- Expédition de Gentrepression en Draenor	
	};

local OneSideFactions = {
	["Horde"] = {2159, 2160, 2161, 2162, 2400},
	["Alliance"] = {2103, 2156, 2157, 2158, 2373},
	};
local FactionLevelInfos = {
	{FACTION_STANDING_LABEL1, 1, 0, 0, -42000},	--Haï 1
	{FACTION_STANDING_LABEL2, 1, 0, 0, -6000},	--Hostile 2
	{FACTION_STANDING_LABEL3, 1, 0, 0, -3000},	--Inamical 3
	{FACTION_STANDING_LABEL4, 1, 1, 0, 0},	--Neutre 4
	{FACTION_STANDING_LABEL5, 1, 1, 0, 3000},	--Amical 5
	{FACTION_STANDING_LABEL6, 0.70, 1, 0, 9000},	--Honoré 6
	{FACTION_STANDING_LABEL7, 0, 1, 0, 21000},	--Révéré 7
	{FACTION_STANDING_LABEL8, 0, 1, 0, 42000},	--Exalté 8
	{"Parangon", 0.9, 0.8, 0.5, 43000},	--Parangon 9
	{" ", 1, 1, 1},	--Rien 10
	};	
local VenariLevelInfos = {	
	{"Dubious", 1, 0, 0, 1000},				--Dubious 1
	{"Apprehensive", 1, 0, 0, 7000},		--Apprehensive 2
	{"Tentative", 1, 1, 0, 14000},			--Tentative 3
	{"Ambivalent", 1, 1, 0, 21000},			--Ambivalent 4
	{"Cordial", 0.70, 1, 0, 41999},			--Cordial 5
	{"Appreciative", 0.70, 1, 0, 42000},	--Appreciative 6
	{" ", 1, 1, 1, 42000},	--Rien 7
	{" ", 1, 1, 1, 42000},	--Rien 8
	{" ", 0.9, 0.8, 0.5, 43000},	--Rien 9	
	};
local CourtofNightInfos = {
	{FACTION_STANDING_LABEL4, 1, 1, 0, 3000},
	{FACTION_STANDING_LABEL5, 1, 1, 0, 6000},
	{FACTION_STANDING_LABEL6, 0.7, 1, 0, 12000},
	{FACTION_STANDING_LABEL7, 0, 1, 0, 21000},
	{FACTION_STANDING_LABEL8, 0, 1, 0, 41999},
	};
local IrionLevelInfos = {	
	{"Connaissance", 1, 1, 0, 8400},		--Connaissance 1
	{"Complicité", 1, 1, 0, 16800},			--Complicité 2
	{"Acolyte", 1, 1, 0, 25200},			--Acolyte 3
	{"Croc", 1, 1, 0, 33600},				--Croc 4
	{"Amitié", 0.70, 1, 0, 41999},			--Amitié 5
	{"Amitié sincère", 0.70, 1, 0, 42000},	--Amitié sincère 6
	{" ", 1, 1, 1, 42000},					--Rien 7
	{" ", 1, 1, 1, 42000},					--Rien 8
	{" ", 0.9, 0.8, 0.5, 43000},			--Rien 9	
	};	
local ConsortiumArtisanatInfos = {	
	{"Indifférence", 1, 1, 0, 500},		--Indifférence 1
	{"Bienveillance", 1, 1, 0, 2500},	--Bienveillance 2
	{"Respect", 1, 1, 0, 5500},			--Respect 3
	{"Estime", 0.7, 1, 0, 12499},		--Estime 4
	{"Admiration", 0.7, 1, 0, 12500},	--Admiration 5
	{" ", 1, 1, 0, 42000},				--Rien 6
	{" ", 1, 1, 1, 42000},				--Rien 7
	{" ", 1, 1, 1, 42000},				--Rien 8
	{" ", 0.9, 0.8, 0.5, 43000},		--Rien 9	
	};
local CobaltInfos = {	
	{"Vide", 1, 1, 0, 300},			--Vide 1
	{"Faible", 1, 1, 0, 1200},		--Faible 2
	{"Moyenne", 1, 1, 0, 3600},		--Moyenne 3
	{"Élevée", 0.7, 1, 0, 9999},	--Élevée 4
	{"Maximum", 0.7, 1, 0, 10000},	--Maximum 5
	{" ", 1, 1, 0, 42000},			--Rien 6
	{" ", 1, 1, 1, 42000},			--Rien 7
	{" ", 1, 1, 1, 42000},			--Rien 8
	{" ", 0.9, 0.8, 0.5, 43000},	--Rien 9	
	};
	
function TracerData.Function:WindowCreateReputations()
	--Update DB pour les mounts/toys/companions
	-- TracerDB.testmountsid = C_MountJournal.GetMountIDs();
	-- TracerDB.testmountsinfos = {};
	-- for index, value in ipairs(TracerDB.testmountsid) do
		-- TracerDB.testmountsinfos[index] = {};
		-- TracerDB.testmountsinfos[index][1] = value;	
		-- local creatureName, _, _, _, _, _, _, _, _, _, isCollected, _ = C_MountJournal.GetMountInfoByID(value);
		-- TracerDB.testmountsinfos[index][2] = creatureName;		
	-- end
	-- TracerDB.testmountsid = nil;
	
	TracerData.FactionsRewardInfos = {
		["Mounts"] = {
			--BfA
			[2103] = { -- Empire Zandalari (H)
				{1058, FACTION_STANDING_LABEL8},
				},
			[2156] = { -- Expedition de Talanji (H)
				{1061, FACTION_STANDING_LABEL8},
				},		
			[2158] = { -- Volduni (H)
				{926, FACTION_STANDING_LABEL8},
				},
			[2160] = {	--Amirauté des Portvaillants
				{1010, FACTION_STANDING_LABEL8},
				{1064, FACTION_STANDING_LABEL8.." +HF"},
				},
			[2161] = { -- Ordre des Braises (A)
				{1016, FACTION_STANDING_LABEL8},
				},
			[2162] = { -- Sillage des tempêtes (A)
				{1015, FACTION_STANDING_LABEL8},
				},
			[2373] = { -- Les Affranchis (H)
				{1230, FACTION_STANDING_LABEL8},
				},
			[2391] = { -- Résistance de Mécarouille
				{1254, FACTION_STANDING_LABEL8},
				},
			[2400] = { -- Ankoïens du brisant (A)
				{1231, FACTION_STANDING_LABEL8},
				},
			[2415] = { -- Rajani
				{1313, FACTION_STANDING_LABEL8},
				},	
			[2417] = { -- Accord Uldum
				{1318, FACTION_STANDING_LABEL8},
				},				
			--Legion
			--WoD
			},
		["Toys"] = {
			--BfA
			[2160] = {	--Amirauté des Portvaillants
				{163201, FACTION_STANDING_LABEL6},
				{163200, FACTION_STANDING_LABEL7},
				{166702, TracerData.L["Parangon"]},
				},
			[2158] = {	--Voldunai
				{163211, FACTION_STANDING_LABEL6},
				{159753, FACTION_STANDING_LABEL6},
				{165021, FACTION_STANDING_LABEL8},
				{166703, TracerData.L["Parangon"]},
				{166880, TracerData.L["Parangon"]},
				},
			[2103] = {	--Empire Zandalari
				{163210, FACTION_STANDING_LABEL7},
				{166701, TracerData.L["Parangon"]},
				},
			[2162] = {	--Sillage des tempêtes
				{163463, FACTION_STANDING_LABEL7},
				},
			[2156] = {	--Expedition de Talanji
				{166308, TracerData.L["Parangon"]},
				},
			[2157] = { --Brigade de l'honneur
				{166879, TracerData.L["Parangon"]},
				},
			[2159] = {	--7e Legion
				{166879, TracerData.L["Parangon"]},
				},
			[2161] = {	--Ordre des braises
				{166808, TracerData.L["Parangon"]},
				},
			[2163] = {	--Chercheurs tortollans
				{166704, TracerData.L["Parangon"]},
				},
			[2164] = {	--Champions d'Azeroth
				{166877, TracerData.L["Parangon"]},
				},
			[2373] = {	--Les Affranchis
				{170203, TracerData.L["Parangon"]},
				{170469, TracerData.L["Parangon"]},
				},
			[2400] = {	--Ankoïens du brisant
				{170203, TracerData.L["Parangon"]},
				{170469, TracerData.L["Parangon"]},
				},
			[2391] = {	--Résistance de Mécarouille
				{169108, FACTION_STANDING_LABEL7},
				},
			[2417] = { -- Accord Uldum
				{174995, TracerData.L["Parangon"]},
				},				
			--Legion
			--WoD	
			},
		["Companions"] = {
			[2160] = {	--Amirauté des Portvaillants
				{2566, TracerData.L["Parangon"]},
				},			
			[2156] = { -- Expedition de Talanji (H)
				{2415, FACTION_STANDING_LABEL7},
				{2567, TracerData.L["Parangon"]},				
				},
			[2157] = { -- Brigade de l'honneur (H)
				{2444, FACTION_STANDING_LABEL7},
				},		
			[2159] = { -- 7e Legion (A)
				{2443, FACTION_STANDING_LABEL7},
				},
			[2161] = { -- Ordre des Braises (A)
				{2405, FACTION_STANDING_LABEL7},
				{2568, TracerData.L["Parangon"]},				
				},
			[2162] = { -- Sillage des tempêtes (A)
				{2404, FACTION_STANDING_LABEL7},
				{2569, TracerData.L["Parangon"]},				
				},
			[2163] = { -- Chercheurs Tortollans
				{2427, FACTION_STANDING_LABEL7},
				},
			[2164] = { -- Champions d'Azeroth
				{2439, FACTION_STANDING_LABEL7},
				{2429, FACTION_STANDING_LABEL7},
				},
			[2373] = { -- Les Affranchis (H)
				{2699, FACTION_STANDING_LABEL7},
				},
			[2391] = { -- Résistance de Mécarouille
				{2713, FACTION_STANDING_LABEL6},
				},
			[2400] = { -- Ankoïens du brisant (A)
				{2698, FACTION_STANDING_LABEL7},
				},	
			[2415] = { -- Rajani
				{2852, TracerData.L["Parangon"]},
				},
			[2417] = { -- Accord Uldum
				{2850, TracerData.L["Parangon"]},
				{2849, FACTION_STANDING_LABEL7},				
				},				
			},		
	}

	--Création de la sauvegarde dans le SavedVariable	
	if (TracerDB.Factions == nil) or (#TracerDB.Factions ~= 53) then
		TracerDB.Factions = TracerData.FactionsInfos;	
	end
	--Update de la DB pour les noms des factions
	for index, value in ipairs(TracerDB.Factions) do
		local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfoByID(value[1])
		if name then
			TracerDB.Factions[index][2] = name;
		end
	end
	--Rangement par ordre alphabétique
	--On procède au tri des noms connus
	local t1 = {};
	local j = 1;
	for index, value in ipairs(TracerDB.Factions) do
		if value[2] ~= " " then
			t1[j] = value[2]
			j = j + 1;
		end
	end
	table.sort(t1);	
	--On recrée la table avec les noms
	local t2 = {};
	for index, value in ipairs(t1) do
		for index1, value1 in ipairs(TracerDB.Factions) do
			if value == value1[2] then
				t2[index] = TracerDB.Factions[index1];
			end
		end
	end
	for index, value in ipairs(TracerDB.Factions) do
		if value[2] == " " then
			table.insert(t2, value);
		end
	end
	TracerDB.Factions = t2;		
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[5];
	TracerDB.ListLine[5] = {};
	for index, value in ipairs(TracerDB.Factions) do
		TracerDB.ListLine[5][index] = value[2]
	end	
	--Création de la catégorie
	TracerData.Function:WindowCreate(5, headername);

	--Copie des DisplayLine
	for index, value in ipairs(TracerDB.Factions) do
		TracerDB.Options.DisplayLine[5][index][1] = value[4];
	end	
	
	--Affichage
	--TracerData.Function:WindowUpdateReputations();
	
	--Tootltip pour les récompenses de réputations
	-- for index, value in ipairs(TracerDB.Factions) do			
		-- TracerData.Lines[5][index]:SetScript("OnEnter", function()
			-- TracerData.Function:FactionsRewardsTooltip(index);
		-- end);
		-- TracerData.Lines[5][index]:SetScript("OnLeave", function()
			-- GameTooltip:Hide();
		-- end);
	-- end		
	
	--Tooltip pour les réputations
	for index, value in ipairs(TracerData.ListToons) do
		for index1, value1 in ipairs(TracerDB.Factions) do			
			TracerData.Lines[5]["Toon"..index][index1]:SetScript("OnEnter", function()
				TracerData.Function:FactionsTooltip(value, index1, value1);
			end);
			TracerData.Lines[5]["Toon"..index][index1]:SetScript("OnLeave", function()
				GameTooltip:Hide();
			end);
		end
	end	
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	--Gestion Monnaies
	TracerData.Headers[5]:RegisterEvent("UPDATE_FACTION");	
	TracerData.Headers[5]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Headers[5]:RegisterEvent("MAJOR_FACTION_RENOWN_LEVEL_CHANGED");
	TracerData.Headers[5]:SetScript("OnEvent", function(_, event) 
		C_Timer.After(3, function() TracerData.Function:UpdateFactions() end) 
	end)
end

function TracerData.Function:WindowUpdateReputations()
	local r, g, b = 0, 0, 0;
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[5] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					for index2, value2 in ipairs(TracerDB.Factions) do						
						if TracerDB.Options.DisplayLine[5][index2][1] then
							--Vénari 2432 (SL)
							--Cour de la nuit 2464 (SL)
							if (value2[1] == 2432) or (value2[1] == 2464) then
								r = VenariLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][2];
								g = VenariLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][3];
								b = VenariLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][4];
								TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture(nil);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetTextColor(r, g, b);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(TracerDB.Toons[value]["Factions"][value2[1]][5]);												
							--Irion et Sabellian
							elseif (value2[1] == 2517) or (value2[1] == 2518) then
								r = IrionLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][2];
								g = IrionLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][3];
								b = IrionLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][4];
								TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture(nil);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetTextColor(r, g, b);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(TracerDB.Toons[value]["Factions"][value2[1]][5]);
							--Consortium d'artisanat
							elseif value2[1] == 2544 then
								r = ConsortiumArtisanatInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][2];
								g = ConsortiumArtisanatInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][3];
								b = ConsortiumArtisanatInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][4];
								TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture(nil);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetTextColor(r, g, b);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(TracerDB.Toons[value]["Factions"][value2[1]][5]);
							--Cobalt
							elseif value2[1] == 2550 then
								r = CobaltInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][2];
								g = CobaltInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][3];
								b = CobaltInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][4];
								TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture(nil);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetTextColor(r, g, b);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(TracerDB.Toons[value]["Factions"][value2[1]][5]);	
							--MajorFactions
							elseif ((value2[1] == 2503) or (value2[1] == 2507) or (value2[1] == 2511) or (value2[1] == 2510)) and (TracerDB.Toons[value]["Factions"][value2[1]][1] ~= 9) then
								TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture(nil);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetTextColor(0, 1, 0);
								TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(TracerDB.Toons[value]["Factions"][value2[1]][5]);						
							--Autre réputations
							else
								r = FactionLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][2];
								g = FactionLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][3];
								b = FactionLevelInfos[TracerDB.Toons[value]["Factions"][value2[1]][1]][4];
								if (TracerDB.Toons[value]["Factions"][value2[1]][1] == 9) and (TracerDB.Toons[value]["Factions"][value2[1]][5] == "100") then
									TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(nil);
									TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								else
									TracerData.Lines[5]["Toon"..index][index2]["Texture2"]:SetTexture(nil);
									TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetTextColor(r, g, b);
									TracerData.Lines[5]["Toon"..index][index2]["Title"]:SetText(TracerDB.Toons[value]["Factions"][value2[1]][5]);
								end
							end
						end
					end
				end
			end
		end
	end
end

function TracerData.Function:UpdateFactions()
	local currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon;
	local reputpurcent;
	local reputation;
	local rankrep;
	local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus;
	local renownLevel;
	--print("Update Factions")
	-- local idfactiontest = 2464;
	-- TracerDB.test = {};
	-- TracerDB.test.rankInfo = C_GossipInfo.GetFriendshipReputationRanks(idfactiontest);
	-- TracerDB.test.reputation = C_GossipInfo.GetFriendshipReputation(idfactiontest);
	-- TracerDB.test.inforep = {};
	-- local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfoByID(idfactiontest);			
	-- TracerDB.test.inforep["name"]=name;
	-- TracerDB.test.inforep["description"]=description;
	-- TracerDB.test.inforep["standingID"]=standingID;
	-- TracerDB.test.inforep["barMin"]=barMin;
	-- TracerDB.test.inforep["barMax"]=barMax;
	-- TracerDB.test.inforep["barValue"]=barValue;
	-- TracerDB.test.inforep["atWarWith"]=atWarWith;
	-- TracerDB.test.inforep["canToggleAtWar"]=canToggleAtWar;
	-- TracerDB.test.inforep["isHeader"]=isHeader;
	-- TracerDB.test.inforep["isCollapsed"]=isCollapsed;
	-- TracerDB.test.inforep["hasRep"]=hasRep;
	-- TracerDB.test.inforep["isWatched"]=isWatched;
	-- TracerDB.test.inforep["isChild"]=isChild;
	-- TracerDB.test.inforep["factionID"]=factionID;
	-- TracerDB.test.inforep["hasBonusRepGain"]=hasBonusRepGain;
	-- TracerDB.test.inforep["canBeLFGBonus"]=canBeLFGBonus;
	
	for index, value in ipairs(TracerDB.Factions) do
		--Major Faction (DF)
		if (value[1] == 2503) or (value[1] == 2507) or (value[1] == 2511) or (value[1] == 2510) then
			if C_Reputation.IsFactionParagon(value[1]) then
				currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon = C_Reputation.GetFactionParagonInfo(value[1]);			
				if currentValue then
					while (currentValue >= 7500) do
						currentValue = currentValue - 7500;
					end			
					reputpurcent = math.floor(currentValue/10)/10;
					if hasRewardPending then
						reputpurcent = 100;
					end	
					
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = 9;
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = currentValue;
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = 7500;			
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = hasRewardPending;
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(reputpurcent);
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][6] = "Parangon";				
				end
			else
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = C_MajorFactions.GetMajorFactionData(value[1])["renownLevel"];
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = C_MajorFactions.GetMajorFactionData(value[1])["renownLevelThreshold"];
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = C_MajorFactions.GetMajorFactionData(value[1])["renownReputationEarned"];
			end
		--Parangon			
		elseif C_Reputation.IsFactionParagon(value[1]) then		
			currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon = C_Reputation.GetFactionParagonInfo(value[1]);			
			if currentValue then
				while (currentValue >= 10000) do
					currentValue = currentValue - 10000;
				end			
				reputpurcent = math.floor(currentValue/10)/10;
				if hasRewardPending then
					reputpurcent = 100;
				end	
				
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = 9;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = currentValue;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = 10000;			
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = hasRewardPending;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(reputpurcent);
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][6] = "Parangon";				
			end
		--Venari 2432 (SL)
		--Cour de la nuit 2464 (SL)
		elseif (value[1] == 2432) or (value[1] == 2464) then
			reputation = C_GossipInfo.GetFriendshipReputation(value[1]);
			if reputation then
				rankrep = 1;
				for index1, value1 in ipairs(VenariLevelInfos) do
					if reputation.standing < VenariLevelInfos[index1][5] then
						rankrep = index1;
						break;
					end
				end
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = rankrep;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = reputation.standing - reputation.reactionThreshold;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = reputation.nextThreshold - reputation.reactionThreshold;			
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = false;
				if reputation.reactionThreshold ~= 0 then
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(math.floor(((reputation.standing - reputation.reactionThreshold)/(reputation.nextThreshold - reputation.reactionThreshold))*1000)/10);				
				else
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = "0";
				end
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][6] = reputation.reaction;								
			end		
		--Irion 2517 (DF)		
		--Sabellian 2518 (DF)		
		elseif (value[1] == 2517) or (value[1] == 2518) then
			reputation = C_GossipInfo.GetFriendshipReputation(value[1]);
			if reputation then
				rankrep = 1;
				for index1, value1 in ipairs(IrionLevelInfos) do
					if reputation.standing < IrionLevelInfos[index1][5] then
						rankrep = index1;
						break;
					end
				end			
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = rankrep;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = reputation.standing - reputation.reactionThreshold;
				if reputation.nextThreshold then
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = reputation.nextThreshold - reputation.reactionThreshold;
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(math.floor(((reputation.standing - reputation.reactionThreshold)/(reputation.nextThreshold - reputation.reactionThreshold))*1000)/10);
				else
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = 0;
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = "100";				
				end						
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = false;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][6] = reputation.reaction;								
			end
		--Consortium d'Artisanat 2544 (DF)		
		elseif value[1] == 2544 then
			reputation = C_GossipInfo.GetFriendshipReputation(value[1]);
			if reputation then
				rankrep = 1;
				for index1, value1 in ipairs(ConsortiumArtisanatInfos) do
					if reputation.standing < ConsortiumArtisanatInfos[index1][5] then
						rankrep = index1;
						break;
					end
				end
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = rankrep;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = reputation.standing - reputation.reactionThreshold;
				if reputation.nextThreshold then				
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = reputation.nextThreshold - reputation.reactionThreshold;			
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(math.floor(((reputation.standing - reputation.reactionThreshold)/(reputation.nextThreshold - reputation.reactionThreshold))*1000)/10);				
				else
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = 0;			
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = "100";								
				end			
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = false;
				if reputation.reactionThreshold ~= 0 then
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(math.floor(((reputation.standing - reputation.reactionThreshold)/(reputation.nextThreshold - reputation.reactionThreshold))*1000)/10);				
				else
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = "0";
				end
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][6] = reputation.reaction;								
			end
		--Cobalt 2550 (DF)		
		elseif value[1] == 2550 then
			reputation = C_GossipInfo.GetFriendshipReputation(value[1]);
			if reputation then
				rankrep = 1;
				for index1, value1 in ipairs(CobaltInfos) do
					if reputation.standing < CobaltInfos[index1][5] then
						rankrep = index1;
						break;
					end
				end
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = rankrep;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = reputation.standing - reputation.reactionThreshold;
				if reputation.nextThreshold then				
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = reputation.nextThreshold - reputation.reactionThreshold;			
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(math.floor(((reputation.standing - reputation.reactionThreshold)/(reputation.nextThreshold - reputation.reactionThreshold))*1000)/10);				
				else
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = 0;			
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = "100";								
				end
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = false;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][6] = reputation.reaction;								
			end			
		--Non Parangon		
		else
			name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfoByID(value[1]);			
			if standingID == 0 then
				standingID = 10;
			end
			if name then
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = standingID;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = barValue - barMin;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = barMax-barMin;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = false;
				if (standingID) == 8 then
					TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(100);
				else
					if barMax-barMin ~= 0 then
						TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = tostring(math.floor(((barValue - barMin)/(barMax-barMin))*1000)/10);
					else
						TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = "NA";
					end
				end
			else
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][1] = 10;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][2] = 0;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][3] = 0;
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][4] = false;					
				TracerDB.Toons[TracerData.thisToon]["Factions"][value[1]][5] = " ";			
			end
		end		
	end	
	--Gestion des factions spécifiques
	if UnitFactionGroup("player") ~= "Neutral" then
		for index, value in ipairs(OneSideFactions[UnitFactionGroup("player")]) do					
			TracerDB.Toons[TracerData.thisToon]["Factions"][value][5] = " ";
		end
	end
	
	--Affichage
	--TracerData.Function:WindowUpdateReputations();
end

function TracerData.Function:FactionsTooltip(value, index1, value1)
	local r, g, b;
	local rank;
	local current;
	local total;
	local chest;
	local text;	
	local rankname;
	
	--Venari 2432 (SL)
	if value1[1] == 2432 then
		r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"];
		rank = TracerDB.Toons[value]["Factions"][value1[1]][1];
		current = TracerDB.Toons[value]["Factions"][value1[1]][2];
		total = TracerDB.Toons[value]["Factions"][value1[1]][3];
		chest = TracerDB.Toons[value]["Factions"][value1[1]][4];
		text = TracerDB.Toons[value]["Factions"][value1[1]][5];	
		rankname = TracerDB.Toons[value]["Factions"][value1[1]][6];
		
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
		GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
		GameTooltip:AddLine();
		if rank ~= 9 then		
			GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname.." ("..rank.."/6)", 1, 1, 1, VenariLevelInfos[rank][2], VenariLevelInfos[rank][3], VenariLevelInfos[rank][4]);
		else
			GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname, 1, 1, 1, VenariLevelInfos[rank][2], VenariLevelInfos[rank][3], VenariLevelInfos[rank][4]);		
		end
		GameTooltip:AddDoubleLine(tostring(TracerDB.Toons[value]["Factions"][value1[1]][2]).."/"..tostring(TracerDB.Toons[value]["Factions"][value1[1]][3]), TracerDB.Toons[value]["Factions"][value1[1]][5], 1, 1, 1, 1 ,1, 1);
		if (rank ~= 7) and (text ~= " ") then
			GameTooltip:Show();
		end
	--Cour de la nuit 2464 (SL)
	elseif value1[1] == 2464 then
		r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"];
		label = TracerDB.Toons[value]["Factions"][value1[1]][1];
		current = TracerDB.Toons[value]["Factions"][value1[1]][2];
		total = TracerDB.Toons[value]["Factions"][value1[1]][3];
		chest = TracerDB.Toons[value]["Factions"][value1[1]][4];
		text = TracerDB.Toons[value]["Factions"][value1[1]][5];
		rankname = TracerDB.Toons[value]["Factions"][value1[1]][6];
		
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
		GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
		GameTooltip:AddLine();
		GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname, 1, 1, 1, CourtofNightInfos[label][2], CourtofNightInfos[label][3], CourtofNightInfos[label][4]);
		GameTooltip:AddDoubleLine(tostring(TracerDB.Toons[value]["Factions"][value1[1]][2]).."/"..tostring(TracerDB.Toons[value]["Factions"][value1[1]][3]), TracerDB.Toons[value]["Factions"][value1[1]][5], 1, 1, 1, 1 ,1, 1);
		if (label ~= 10) and (text ~= " ") then
			GameTooltip:Show();
		end
	--Irion 2517 (DF)		
	--Sabellian 2518 (DF)
	elseif (value1[1] == 2517) or (value1[1] == 2518) then
		r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"];
		rank = TracerDB.Toons[value]["Factions"][value1[1]][1];
		current = TracerDB.Toons[value]["Factions"][value1[1]][2];
		total = TracerDB.Toons[value]["Factions"][value1[1]][3];
		chest = TracerDB.Toons[value]["Factions"][value1[1]][4];
		text = TracerDB.Toons[value]["Factions"][value1[1]][5];	
		rankname = TracerDB.Toons[value]["Factions"][value1[1]][6];
		
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
		GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
		GameTooltip:AddLine();
		if rank ~= 9 then		
			GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname.." ("..rank.."/6)", 1, 1, 1, IrionLevelInfos[rank][2], IrionLevelInfos[rank][3], IrionLevelInfos[rank][4]);
		else
			GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname, 1, 1, 1, IrionLevelInfos[rank][2], IrionLevelInfos[rank][3], IrionLevelInfos[rank][4]);		
		end
		GameTooltip:AddDoubleLine(tostring(TracerDB.Toons[value]["Factions"][value1[1]][2]).."/"..tostring(TracerDB.Toons[value]["Factions"][value1[1]][3]), TracerDB.Toons[value]["Factions"][value1[1]][5], 1, 1, 1, 1 ,1, 1);
		if (rank ~= 7) and (text ~= " ") then
			GameTooltip:Show();
		end	
	--Cobalt 2550 (DF)
	elseif value1[1] == 2550 then
		r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"];
		rank = TracerDB.Toons[value]["Factions"][value1[1]][1];
		current = TracerDB.Toons[value]["Factions"][value1[1]][2];
		total = TracerDB.Toons[value]["Factions"][value1[1]][3];
		chest = TracerDB.Toons[value]["Factions"][value1[1]][4];
		text = TracerDB.Toons[value]["Factions"][value1[1]][5];	
		rankname = TracerDB.Toons[value]["Factions"][value1[1]][6];
		
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
		GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
		GameTooltip:AddLine();
		if rank ~= 9 then		
			GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname.." ("..rank.."/5)", 1, 1, 1, CobaltInfos[rank][2], CobaltInfos[rank][3], CobaltInfos[rank][4]);
		else
			GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], rankname, 1, 1, 1, CobaltInfos[rank][2], CobaltInfos[rank][3], CobaltInfos[rank][4]);		
		end
		GameTooltip:AddDoubleLine(tostring(TracerDB.Toons[value]["Factions"][value1[1]][2]).."/"..tostring(TracerDB.Toons[value]["Factions"][value1[1]][3]), TracerDB.Toons[value]["Factions"][value1[1]][5], 1, 1, 1, 1 ,1, 1);
		if (rank ~= 7) and (text ~= " ") then
			GameTooltip:Show();
		end		
	--MajorFaction (DF)
	elseif (value1[1] == 2503) or (value1[1] == 2507) or (value1[1] == 2511) or (value1[1] == 2510) then
		r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"];
		label = TracerDB.Toons[value]["Factions"][value1[1]][1];
		current = TracerDB.Toons[value]["Factions"][value1[1]][2];
		total = TracerDB.Toons[value]["Factions"][value1[1]][3];
		chest = TracerDB.Toons[value]["Factions"][value1[1]][4];
		text = TracerDB.Toons[value]["Factions"][value1[1]][5];
		
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
		GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
		GameTooltip:AddLine();
		GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], TracerData.L["Renom"], 1, 1, 1, 1, 1, 1);
		GameTooltip:AddDoubleLine(tostring(TracerDB.Toons[value]["Factions"][value1[1]][2]).."/"..tostring(TracerDB.Toons[value]["Factions"][value1[1]][3]), TracerDB.Toons[value]["Factions"][value1[1]][5], 1, 1, 1, 1 ,1, 1);
		if (label ~= 10) and (text ~= " ") then
			GameTooltip:Show();
		end	
	-- Le reste
	else
		r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"];
		label = TracerDB.Toons[value]["Factions"][value1[1]][1];
		current = TracerDB.Toons[value]["Factions"][value1[1]][2];
		total = TracerDB.Toons[value]["Factions"][value1[1]][3];
		chest = TracerDB.Toons[value]["Factions"][value1[1]][4];
		text = TracerDB.Toons[value]["Factions"][value1[1]][5];
		
		GameTooltip:Hide();
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
		GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
		GameTooltip:AddLine();
		GameTooltip:AddDoubleLine(TracerDB.Factions[index1][2], FactionLevelInfos[label][1], 1, 1, 1, FactionLevelInfos[label][2], FactionLevelInfos[label][3], FactionLevelInfos[label][4]);
		GameTooltip:AddDoubleLine(tostring(TracerDB.Toons[value]["Factions"][value1[1]][2]).."/"..tostring(TracerDB.Toons[value]["Factions"][value1[1]][3]), TracerDB.Toons[value]["Factions"][value1[1]][5], 1, 1, 1, 1 ,1, 1);
		if (label ~= 10) and (text ~= " ") then
			GameTooltip:Show();
		end
	end
end

function TracerData.Function:FactionsRewardsTooltip(index)
	local faction = TracerDB.Factions[index];
	
	GameTooltip:Hide();
	GameTooltip:SetBackdropColor(0, 0, 0, 1);
	
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(faction[2]);
	GameTooltip:AddLine(" ");
	if TracerData.FactionsRewardInfos["Mounts"][faction[1]] then
		GameTooltip:AddLine(TracerData.L["Montures"]);
		for index, value in ipairs(TracerData.FactionsRewardInfos["Mounts"][faction[1]]) do
			local creatureName, _, _, _, _, _, _, _, _, _, isCollected, _ = C_MountJournal.GetMountInfoByID(value[1]);
			if isCollected then
				GameTooltip:AddDoubleLine(creatureName, value[2], 0, 1, 0, 1, 1, 1);
			else
				GameTooltip:AddDoubleLine(creatureName, value[2], 1, 0, 0, 1, 1, 1);
			end
		end
		GameTooltip:AddLine(" ");
	end
	if TracerData.FactionsRewardInfos["Toys"][faction[1]] then
		GameTooltip:AddLine(TracerData.L["Jouets"]);
		for index, value in ipairs(TracerData.FactionsRewardInfos["Toys"][faction[1]]) do
			local itemID, toyName, _, _, _, _ = C_ToyBox.GetToyInfo(value[1]);
			if PlayerHasToy(value[1]) then
				GameTooltip:AddDoubleLine(toyName, value[2], 0, 1, 0, 1, 1, 1);
			else
				GameTooltip:AddDoubleLine(toyName, value[2], 1, 0, 0, 1, 1, 1);
			end
		end
		GameTooltip:AddLine(" ");
	end
	if TracerData.FactionsRewardInfos["Companions"][faction[1]] then
		GameTooltip:AddLine(TracerData.L["Mascottes"]);
		for index, value in ipairs(TracerData.FactionsRewardInfos["Companions"][faction[1]]) do
			local speciesName, _, _, _, _, _, _, _, _, _, _, _ = C_PetJournal.GetPetInfoBySpeciesID(value[1])
			if C_PetJournal.GetOwnedBattlePetString(value[1]) then
				GameTooltip:AddDoubleLine(speciesName, value[2], 0, 1, 0, 1, 1, 1);
			else
				GameTooltip:AddDoubleLine(speciesName, value[2], 1, 0, 0, 1, 1, 1);
			end
		end
		GameTooltip:AddLine(" ");
	end
	GameTooltip:Show();
end
